<template>
  <v-dialog v-model="dialog" persistent max-width="800px">
    <v-card>
      <DialogRemark
        v-if="obj.status === 'WE' || obj.status === 'R'"
        :dialog="dialogRemark"
        :remark="obj.remark"
        :close.sync="dialogRemark"
      />
      <v-card-title>
        <span class="headline">
          <v-icon color="info"> map </v-icon>
          รายละเอียดพื้นที่
        </span>
        <v-chip
          class="ma-2"
          @click="dialogRemark = true"
          v-if="obj.status === 'WE' || obj.status === 'R'"
        >
          เหตุผล Read more <v-icon color="info"> label_important </v-icon>
        </v-chip>
        <v-spacer></v-spacer>
        <v-chip
          class="ma-2"
          color="primary"
          label
          outlined
          v-if="role === 'Admin'"
        >
          ชื่อ Partner:
          {{ obj.fullName }}
        </v-chip>
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12">
              <gmap-map
                v-if="obj.status === 'WE' && role === 'Partner'"
                :center="center"
                :zoom="15"
                style="width: 100%; height: 400px"
                @click="mark"
              >
                <gmap-marker
                  :key="index"
                  v-for="(m, index) in markers"
                  :position="m.position"
                  @click="center = m.position"
                  :clickable="true"
                >
                </gmap-marker>
              </gmap-map>
              <gmap-map
                v-else
                :center="center"
                :zoom="15"
                style="width: 100%; height: 400px"
              >
                <gmap-marker
                  :position="center"
                  :clickable="false"
                >
                </gmap-marker>
              </gmap-map>
            </v-col>
            <v-col cols="12">
              <AutoCompleteMap
                @addMarker="addMarker"
                v-if="obj.status === 'WE' && role === 'Partner'"
              />
            </v-col>
            <v-form ref="form" v-model="valid" lazy-validation>
              <InputLocation v-model="objLocal" :disabled="true" />
            </v-form>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="success darken-1"
          text
          @click="openDialog('approve')"
          v-if="obj.status === 'W' && role === 'Admin'"
        >
          อนุมัติ
        </v-btn>
        <v-btn
          color="orange darken-1"
          text
          @click="openDialog('locationEdit')"
          v-if="obj.status === 'WE' && role === 'Partner'"
        >
          แก้ไขฟอร์ม
        </v-btn>
        <v-btn
          color="orange darken-1"
          text
          @click="openDialog('rejectEdit')"
          v-if="obj.status === 'W' && role === 'Admin'"
        >
          ส่งกลับเพื่อแก้ไขข้อมูล
        </v-btn>
        <v-btn
          color="red darken-1"
          text
          @click="openDialog('reject')"
          v-if="obj.status === 'W' && role === 'Admin'"
        >
          ไม่อนุมัติ
        </v-btn>

        <v-btn color="info darken-1" text @click="$emit('update:close', false)">
          ปิด
        </v-btn>
      </v-card-actions>
    </v-card>

    <DialogConfirm
      :dialog="dialogConfirm"
      v-model="remark"
      :title="objDialog.title"
      :status="status"
    >
      <template v-slot:confirm>
        <v-btn
          color="success"
          text
          :disabled="loading"
          :loading="loading"
          @click="
            status == 'reject'
              ? confirm('reject')
              : status == 'approve'
              ? confirm('approve')
              : status == ''
              ? editLoction()
              : confirm('rejectEdit')
          "
        >
          ใช่
        </v-btn>
      </template>
      <template v-slot:close>
        <v-btn color="error" text :disabled="loading" @click="close">
          ไม่ใช่
        </v-btn>
      </template>
    </DialogConfirm>
  </v-dialog>
</template>

<script>
import InputLocation from "./InputLocation";
import AutoCompleteMap from "./AutoCompleteMap";
import DialogRemark from "../dialog/DialogRemark";
import { LocationModel } from "../../views/contents/location/model/location";
import DialogConfirm from "../dialog/DialogConfirm";
import { GoogleService } from "./google_service/index";
import { gmapApi } from "vue2-google-maps";
export default {
  props: ["dialog", "obj", "center", "overlay"],
  components: {
    AutoCompleteMap,
    DialogRemark,
    DialogConfirm,
    InputLocation,
  },
  model: {
    prop: "obj",
    event: "objChange",
  },
  computed: {
    google: gmapApi,
    objLocal: {
      get: function () {
        return this.obj;
      },
      set: function (value) {
        this.$emit("objChange", value);
      },
    },
  },
  data() {
    return {
      markers: [
        {
          position: {
            lat: this.center.lat,
            lng: this.center.lng,
          },
        },
      ],

      valid: true,
      places: [],
      currentPlace: null,
      objDialog: {},
      loading: false,
      remark: "",
      dialogConfirm: false,
      dialogRemark: false,
      role: this.$store.getters["auth/roleUser"],
      status: "",
    };
  },
  created() {
    this.$gmapApiPromiseLazy().then(() => {
      if (this.google) {
        this.geocoder = new this.google.maps.Geocoder();
      }
    });
  },
  methods: {
    close() {
      this.dialogConfirm = false;
      this.remark = "";
    },
    mark(event) {
      this.markers = [];
      const marker = {
        lat: event.latLng.lat(),
        lng: event.latLng.lng(),
      };
      this.markers.push({ position: marker });
      this.center = marker;
      this.geocoder.geocode({ location: marker }, (results) => {
        let res = GoogleService.googleResult(results, undefined);
        this.objLocal = Object.assign({}, this.objLocal, res);
      });
    },
    addMarker(currentPlace) {
      if (currentPlace) {
        this.markers = [];
        const marker = {
          lat: currentPlace.latitude,
          lng: currentPlace.longtitude,
        };
        this.markers.push({ position: marker });
        this.center = marker;
        this.objLocal = Object.assign({}, this.objLocal, currentPlace);
      }
    },
    openDialog(item) {
      if (item === "rejectEdit") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการให้แก้ไขหรือไม่";
        this.status = "rejectEdit";
      } else if (item === "reject") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการไม่อนุมัติหรือไม่";
        this.status = "reject";
      } else if (item === "locationEdit") {
        const formValid = this.$refs.form.validate();
        if (formValid === true) {
          this.dialogConfirm = true;
          this.objDialog.title = " คุณต้องการแก้ไขข้อมูลหรือไม่";
          this.status = "";
        }
      } else {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการอนุมัติหรือไม่";
        this.status = "approve";
      }
    },
    async editLoction() {
      this.loading = true;
      let param = LocationModel.locationEdit(this.objLocal);
      await this.$store.dispatch("locate/editLocation", param);
      let error = this.$store.getters["locate/error"];
      if (error == false) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ดำเนินการสำเร็จ",
          color: "success",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update:close", false);
        this.$emit("update-table", true);
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ข้อมูลจากระบบผิดพลาด",
          color: "red",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
      }
    },
    async confirm(status) {
      this.loading = true;
      let param = LocationModel.locationApprove(status, this.obj, this.remark);
      await this.$store.dispatch("locate/approveLocation", param);
      let error = this.$store.getters["locate/error"];
      if (error == false) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ดำเนินการสำเร็จ",
          color: "success",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update:close", false);
        this.$emit("update-table", true);
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ข้อมูลจากระบบผิดพลาด",
          color: "red",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
      }
    },
  },
};
</script>

<style>
</style>